-- Main.lua
-- Written by Rod, Habna

-- HugeBag Changelog:
-- 2010/10/5  1.0   - Initial release.

-- HugeBag Knowed bugs:
-- Doom/unload not working properly

-- TODO:
--

import "HabnaPlugins.HugeBag";

frmMain = frmMain();

Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack5, false );


HugeBagCommand = Turbine.ShellCommand();

function HugeBagCommand:Execute( command, arguments )
	if ( arguments == "show" ) then
		Turbine.Shell.WriteLine( "HugeBag: Please use the 'toggle' command instead of 'show'" );
	elseif ( arguments == "hide" ) then
		Turbine.Shell.WriteLine( "HugeBag: Please use the 'toggle' command instead of 'hide'" );
	elseif ( arguments == "toggle" ) then
		HugeBagWin:SetVisible( not HugeBagWin:IsVisible() );
	elseif ( arguments == "version" ) then
		Turbine.Shell.WriteLine( "HugeBag: The current version is: v" .. Version );
	elseif ( arguments == "author" or arguments == "authors" ) then
		Turbine.Shell.WriteLine( "HugeBag: The current authors are: Rod, Extended by Habna" );
	elseif ( arguments == "reset" ) then
		StartVisible = true;
		ShowSlotsInfo = true;
		frmMain:SetSize( 460, 300 );
		frmMain:SetPosition( Turbine.UI.Display.GetWidth() - 15 - 460, Turbine.UI.Display.GetHeight() - 15 - 300 - 55 );
		frmMain:SaveSetting()
		frmMain:SetVisible( true );
		frmMain:PerformLayout()
		Turbine.Shell.WriteLine( "HugeBag: all settings was set back to default" );
	elseif ( arguments == "help" or arguments == "?") then
		Turbine.Shell.WriteLine( "\n ** HugeBag v" .. Version .. " commands **\ntoggle: Toggle visibility on and off, don\'t use 'show' or 'hide'\nreset: Reset location, size and visibility to default\nslotsinfo: Show free, used and max slots in shell\nunload/doom: unload HugeBag (NOT WORKING)\ntoggleslots: show or hide slots information in title\ntoggleshow: show or hide HugeBag at startup\nhelp/?: Show HugeBag commands" );	
	elseif ( arguments == "slotsinfo" ) then
		local usedslots = backpackSize - freeslots;
		Turbine.Shell.WriteLine( "HugeBag: I have " .. freeslots .. " free slots, " .. usedslots .. " used slots and " .. backpackSize .. " max slots" );
	elseif ( arguments == "unload" or arguments == "doom" ) then
		-- not working prooperly
		Turbine.Shell.Execute( "/plugins unload hugebag\r" );
		Turbine.Shell.WriteLine( "HugeBag: unloaded" );
	elseif ( arguments == "toggleshow" ) then
		StartVisible = ( not StartVisible );
		if StartVisible == false then
			Turbine.Shell.WriteLine( "HugeBag: will load hidden next time" );
		else
			Turbine.Shell.WriteLine( "HugeBag: will load visibile next time" );
		end
		frmMain:SaveSetting()
	elseif ( arguments == "toggleslots" ) then
		ShowSlotsInfo = ( not ShowSlotsInfo );
		if ShowSlotsInfo == true then
			Turbine.Shell.WriteLine( "HugeBa: now showing slots informations in the title" );
		else
			Turbine.Shell.WriteLine( "HugeBag: not showing slots informations in the title" );
		end
		frmMain:SaveSetting()
		frmMain:PrintTitle()
	else
		Turbine.Shell.WriteLine( "HugeBag: command not supported" );
	end
end

Turbine.Shell.AddCommand( "HugeBag", HugeBagCommand );
if StartVisible == false then
	Turbine.Shell.WriteLine( "HugeBag: loaded BUT NOT visible" );
else
	Turbine.Shell.WriteLine( "HugeBag: loaded" );
end

Turbine.Plugin.Unload = function( self, sender, args )
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack5, true );
end